<?php
/*
  test_email.php
  TLD 2013.06.06 Test sending emails.
*/

# required include files (in current directory or elsewhere in include path)
require_once 'jsi.php';
require_once 'jsi_config.php';
require_once 'jsi_database.php';
require_once 'jsi_functions.php';
if (EMAIL_PEAR)
  require_once "Mail.php";
if (EMAIL_PEAR && EMAIL_MIME)
  require_once "Mail\mime.php";


# GLOBAL VARIABLES
$g_appname = 'sync';
$g_rep     = '';
$g_newline = "\n";
if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
  $g_newline = "\r\n";
$g_message = '';

// internal functions
function SendEmail($to, $cc, $from, $subject, $body) {
  // note this function requires installing the php PEAR packages: net_smtp and Mail
  if (!EMAIL_PEAR) {
    WarnAndLog('Cannot send email - PEAR Mail not installed or not configured');
    return false;
  }
  if (EMAIL_HOST == '') {
    WarnAndLog('Cannot send email - PEAR Mail Host not configured');
    return false;
  }
  $host     = EMAIL_HOST;
  $username = EMAIL_USER;
  $password = EMAIL_PSWD;
  $headers  = array ('From'    => $from,
                     'To'      => $to,
                     'Subject' => $subject
                    );
  // TLD 2009.10.29 Add CC option
  if ($cc > '' && $cc != $to) {
    $recipients = $to.",".$cc;
    $headers['Cc'] = $cc;
  }
  else
    $recipients = $to;

  // TLD 2009.10.29 Add html attachment
  if (EMAIL_MIME) {
    $message = new Mail_mime();
    $html = '<html><head><title>'
          . $subject 
          . '</title></head>'
          . '<body><pre>'
          . $body 
          . '</pre></body></html>';
    $message->setTXTBody($body);
    $message->setHTMLBody($html);
    $body = $message->get();
    $headers = $message->headers($headers);
  }

  $params = array ('host'     => $host,
                   'auth'     => true,
                   'port'     => 25,
                   'username' => $username,
                   'password' => $password
                  );
  $smtp = & Mail::factory('smtp', $params);
  $mail = $smtp->send($recipients, $headers, $body);
  if (PEAR::isError($mail)) {
    WarnAndLog('Error sending email: ' . $mail->getMessage());
    return false;
  }
  else {
    WriteLog("Email sent to $recipients with subject: $subject");
    return true;
  }
}

// public functions
function SendTestEmail() {
  $to   = EMAIL_TO;
  $cc   = EMAIL_CC;
  $from = EMAIL_FROM;
  $subject = "Test Email";
  $body = " Body of Test Email";
  SendEmail($to, $cc, $from, $subject, $body);
}
function CLI_To_CGI() {
  if ( CLI_CLIENT &&
       isset($_SERVER['argc']) &&
       isset($_SERVER['argv']) &&
       $_SERVER['argc'] > 0 ) {
    for ($i=1;$i<$_SERVER['argc'];$i++) {
      parse_str($_SERVER['argv'][$i],$tmp);
      $_REQUEST = array_merge($_REQUEST, $tmp);
    }
  }
}

/* ** main logic section **
** get procedure name, edit it and run it if ok
** log each request to a text log file
*/
CLI_To_CGI();
$proc  = GetParam('ProcName');
$g_rep = GetParam('tRep');
$g_message = '';
CheckLogSize();
BeginLogEntry();
if (function_exists($proc) and is_callable($proc)) {
   WriteLog("Calling procedure $proc in "
            .basename(__FILE__) . " for rep $g_rep");
   call_user_func($proc);
}
else {
   WarnAndLog("Attempted call to unknown procedure [$proc] in "
              .basename(__FILE__) . " for rep $g_rep" );
}
EndLogEntry();
if ($g_message > ' ') GenericMsg($g_message);

?>
